/* This isn't supposed to be used directly by the user.
 * It's an internal mini3d interface.
 */
#ifndef _MINI3D_RASTERIZER_H_
#define _MINI3D_RASTERIZER_H_

#include "fixed_point.h"

struct frame_buffer {
	uint32_t *color_buffer;
	uint32_t *depth_buffer;
	/*uint8_t *stencil_buffer;*/
	int x, y;
};

struct tex2d {
	uint32_t *pixels;
	int x, y, pix_count;
	int xpow, xmask, ymask;
	unsigned int type;
};

struct vertex {
	fixed x, y, z, w;
	fixed nx, ny, nz;
	fixed vx, vy, vz;
	fixed r, g, b, a;
	fixed u, v;
};

int m3d_rasterizer_setup(struct frame_buffer *fbuf);

void m3d_rstate_sptr(unsigned int *sptr);
void m3d_rstate_blend_ptr(unsigned int *sblend, unsigned int *dblend);
void m3d_rstate_tptr(struct tex2d **tarray, unsigned int *b);

void m3d_draw_line(struct vertex *points);
void m3d_draw_polygon(struct vertex *points, int count);

#endif	/* _MINI3D_RASTERIZER_H_ */
